'use client';
import { useState } from 'react';
import { BuildAreasForm } from '@/pages/build-areas/update/form';
import { useSearchParams, useRouter } from 'next/navigation'
import { Button } from '@/components/ui/button';
import { BuildAreasDataTableUpdate } from './table/data-table';
import { useGraphQlBuildAreasList } from '../queries';

const PageUpdateBuildAreas = () => {
    const [page, setPage] = useState(1);
    const [limit, setLimit] = useState(10);
    const [sort, setSort] = useState({ createdAt: 'desc' });
    const [filters, setFilters] = useState({});
    const searchParams = useSearchParams()
    const router = useRouter()
    const uuid = searchParams?.get('uuid') || null
    const backToBuildAddress = <><div>UUID not found in search params</div><Button onClick={() => router.push('/build-areas')}>Back to Build Areas</Button></>
    const buildId = searchParams?.get('build');
    const noUUIDFound = <><div>Back To Builds. No uuid is found on headers</div><Button onClick={() => router.push('/builds')}>Back to Builds</Button></>
    if (!buildId) { return noUUIDFound }; if (!uuid) { return backToBuildAddress }
    const { data, isLoading, error, refetch } = useGraphQlBuildAreasList({ limit, skip: (page - 1) * limit, sort, filters: { ...filters, buildId, uuid } });
    const initData = data?.data?.[0] || null;
    if (!initData) { return backToBuildAddress }
    return (
        <>
            <BuildAreasDataTableUpdate
                data={data?.data || []} totalCount={data?.totalCount || 0} currentPage={page} pageSize={limit} onPageChange={setPage} onPageSizeChange={setLimit} refetchTable={refetch} buildID={buildId}
            />
            <BuildAreasForm refetchTable={refetch} initData={initData} selectedUuid={uuid} buildId={buildId} />
        </>
    )
}

export { PageUpdateBuildAreas };
